## org.apache.lucene.index
Class SnapshotDeletionPolicy

    java.lang.Object
      org.apache.lucene.index.SnapshotDeletionPolicy

All Implemented Interfaces:
  IndexDeletionPolicy

    public class SnapshotDeletionPolicy

extends java.lang.Object
implements IndexDeletionPolicy

A `IndexDeletionPolicy` that wraps around any other `IndexDeletionPolicy` and adds the ability to hold and later release a single "snapshot" of an index. While the snapshot is held, the `IndexWriter` will not remove any files associated with it even if the index is otherwise being actively, arbitrarily changed. Because we wrap another arbitrary `IndexDeletionPolicy`, this gives you the freedom to continue using whatever `IndexDeletionPolicy` you would normally want to use with your index. Note that you can re-use a single instance of SnapshotDeletionPolicy across multiple writers as long as they are against the same index Directory. Any snapshot held when a writer is closed will "survive" when the next writer is opened.

WARNING: This API is a new and experimental and may suddenly change.

Constructor Summary
`SnapshotDeletionPolicy(IndexDeletionPolicy primary)`

Method Summary
`void` `onCommit(java.util.List commits)` This is called each time the writer completed a commit.
`void` `onInit(java.util.List commits)` This is called once when a writer is first instantiated to give the policy a chance to remove old commit points.
`void` `release()` Release the currently held snapshot.
`IndexCommitPoint` `snapshot()` Take a snapshot of the most recent commit to the index.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SnapshotDeletionPolicy

    public SnapshotDeletionPolicy(IndexDeletionPolicy primary)

Method Detail

### onInit

    public void onInit(java.util.List commits)
                throws java.io.IOException

  Description copied from interface: `IndexDeletionPolicy`

  This is called once when a writer is first instantiated to give the policy a chance to remove old commit points.

  The writer locates all index commits present in the index directory and calls this method. The policy may choose to delete some of the commit points, doing so by calling method `delete()` of `IndexCommit`.

  Note: the last CommitPoint is the most recent one, i.e. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

  Specified by:
    `onInit` in interface `IndexDeletionPolicy`
  Parameters:
    `commits` - List of current `point-in-time commits`, sorted by age (the 0th one is the oldest commit).
  Throws:
    `java.io.IOException`

### onCommit

    public void onCommit(java.util.List commits)
                  throws java.io.IOException

  Description copied from interface: `IndexDeletionPolicy`

  This is called each time the writer completed a commit. This gives the policy a chance to remove old commit points with each commit.

  The policy may now choose to delete old commit points by calling method `delete()` of `IndexCommit`.

  If writer has `autoCommit = true` then this method will in general be called many times during one instance of `IndexWriter`. If `autoCommit = false` then this method is only called once when `IndexWriter.close()` is called, or not at all if the `IndexWriter.abort()` is called.

  Note: the last CommitPoint is the most recent one, i.e. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

  Specified by:
    `onCommit` in interface `IndexDeletionPolicy`
  Parameters:
    `commits` - List of `IndexCommit`, sorted by age (the 0th one is the oldest commit).
  Throws:
    `java.io.IOException`

### snapshot

    public IndexCommitPoint snapshot()

  Take a snapshot of the most recent commit to the index. You must call release() to free this snapshot. Note that while the snapshot is held, the files it references will not be deleted, which will consume additional disk space in your index. If you take a snapshot at a particularly bad time (say just before you call optimize()) then in the worst case this could consume an extra 1X of your total index size, until you release the snapshot.

### release

    public void release()

  Release the currently held snapshot.

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.